/* gtk-knocker version 0.3.0
 * Release date: 1 August 2001
 *
 * Project homepage: http://knocker.sourceforge.net
 *
 * Copyright 2001 Gabriele Giorgetti <g.gabriele@europe.com>
 *
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>

#include "gtk_support.h"
#include "license.h"


GtkWidget* create_about_window (void)
{
  GtkWidget *about_window;
  GtkWidget *main_table;
  GtkWidget *close_hbuttonbox;
  GtkWidget *close_button;
  GtkWidget *hseparator;
  GtkWidget *notebook;
  GtkWidget *table3;
  GtkWidget *logo_pixmap;
  GtkWidget *apptitle_label;
  GtkWidget *copyright_label;
  GtkWidget *homepage_label;
  GtkWidget *about_label;
  GtkWidget *scrolledwindow2;
  GtkWidget *license_text;
  GtkWidget *license_label;

  about_window = gtk_window_new (GTK_WINDOW_TOPLEVEL);

  /* Add the delete event to the window, so it is destroyed if */
  /* the user clicks on the X */
  gtk_signal_connect (GTK_OBJECT (about_window), "delete_event",
 			GTK_SIGNAL_FUNC (gtk_widget_destroy),
 			GTK_OBJECT (about_window));


  gtk_object_set_data (GTK_OBJECT (about_window), "about_window", about_window);
  gtk_container_set_border_width (GTK_CONTAINER (about_window), 13);
  gtk_window_set_title (GTK_WINDOW (about_window), "About gtk-knocker");

  main_table = gtk_table_new (3, 1, FALSE);
  gtk_widget_ref (main_table);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "main_table", main_table,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (main_table);
  gtk_container_add (GTK_CONTAINER (about_window), main_table);

  close_hbuttonbox = gtk_hbutton_box_new ();
  gtk_widget_ref (close_hbuttonbox);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "close_hbuttonbox", close_hbuttonbox,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close_hbuttonbox);
  gtk_table_attach (GTK_TABLE (main_table), close_hbuttonbox, 0, 1, 2, 3,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 5);

  close_button = gtk_button_new_with_label ("Close");


  /* Add on click event that close the window */
  gtk_signal_connect_object (GTK_OBJECT (close_button), "clicked",
   			       GTK_SIGNAL_FUNC (gtk_widget_destroy),
   			       GTK_OBJECT (about_window));



  gtk_widget_ref (close_button);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "close_button", close_button,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (close_button);
  gtk_container_add (GTK_CONTAINER (close_hbuttonbox), close_button);
  GTK_WIDGET_SET_FLAGS (close_button, GTK_CAN_DEFAULT);

  hseparator = gtk_hseparator_new ();
  gtk_widget_ref (hseparator);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "hseparator", hseparator,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator);
  gtk_table_attach (GTK_TABLE (main_table), hseparator, 0, 1, 1, 2,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_FILL), 0, 5);

  notebook = gtk_notebook_new ();
  gtk_widget_ref (notebook);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "notebook", notebook,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (notebook);
  gtk_table_attach (GTK_TABLE (main_table), notebook, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  table3 = gtk_table_new (4, 1, FALSE);
  gtk_widget_ref (table3);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "table3", table3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table3);
  gtk_container_add (GTK_CONTAINER (notebook), table3);

  logo_pixmap = create_pixmap (about_window, "knocker.xpm");
  gtk_widget_ref (logo_pixmap);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "logo_pixmap", logo_pixmap,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (logo_pixmap);
  gtk_table_attach (GTK_TABLE (table3), logo_pixmap, 0, 1, 0, 1,
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);
  gtk_misc_set_padding (GTK_MISC (logo_pixmap), 10, 10);

  apptitle_label = gtk_label_new ("gtk-knocker 0.3.0");
  gtk_widget_ref (apptitle_label);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "apptitle_label", apptitle_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (apptitle_label);
  gtk_table_attach (GTK_TABLE (table3), apptitle_label, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (apptitle_label), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (apptitle_label), 5, 4);

  copyright_label = gtk_label_new ("Copyright (C) 2001 Gabriele Giorgetti <g.gabriele@europe.com>");
  gtk_widget_ref (copyright_label);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "copyright_label", copyright_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (copyright_label);
  gtk_table_attach (GTK_TABLE (table3), copyright_label, 0, 1, 2, 3,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (copyright_label), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (copyright_label), 5, 4);

  homepage_label = gtk_label_new ("Official Home Page: http://knocker.sourceforge.net");
  gtk_widget_ref (homepage_label);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "homepage_label", homepage_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (homepage_label);
  gtk_table_attach (GTK_TABLE (table3), homepage_label, 0, 1, 3, 4,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_misc_set_alignment (GTK_MISC (homepage_label), 0, 0.5);
  gtk_misc_set_padding (GTK_MISC (homepage_label), 5, 4);

  about_label = gtk_label_new ("About");
  gtk_widget_ref (about_label);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "about_label", about_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (about_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 0), about_label);
  gtk_misc_set_padding (GTK_MISC (about_label), 10, 2);

  scrolledwindow2 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_ref (scrolledwindow2);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "scrolledwindow2", scrolledwindow2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (scrolledwindow2);
  gtk_container_add (GTK_CONTAINER (notebook), scrolledwindow2);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow2), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);

  license_text = gtk_text_new (NULL, NULL);
  gtk_widget_ref (license_text);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "license_text", license_text,
                            (GtkDestroyNotify) gtk_widget_unref);


  /* set non editable text */
  gtk_text_set_editable(GTK_TEXT (license_text), FALSE );

  /* Insert the license in the text */
  gtk_text_insert(GTK_TEXT (license_text), NULL, NULL, NULL, LICENSE, -1);



  gtk_widget_show (license_text);
  gtk_container_add (GTK_CONTAINER (scrolledwindow2), license_text);

  license_label = gtk_label_new ("License Agreement");
  gtk_widget_ref (license_label);
  gtk_object_set_data_full (GTK_OBJECT (about_window), "license_label", license_label,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (license_label);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (notebook), 1), license_label);

  return about_window;
}